#ifndef H__dynamoMain
#define H__dynamoMain

#include <wx/timer.h>

#include "AUTO_GENERATED_wxformbuilder.h"
#include "net_types_basic.hpp" /* uintMAC, uintIP, uintPort */

#include "sniffer_custom_wx_event.hpp"  /* On_Screen_Data_For_MAC, EventClass_Sniffer */

#include "sniffer.hpp"
#include "arper.hpp"
//#include "prober.hpp"

class Dialog_Main : public Dialog_Main__Auto_Base_Class {

protected:

    int last_open_tab; /* When socket is re-opened, the previous active tab is navigated to */

    SnifferThread *p_sniffer;
    ArperThread *p_arper;
    //ProberThread *p_prober;

    wxTimer timer_refresh_currently_arping;
    void OnTimerRefreshCurrentlyArping( wxTimerEvent &event );


    void OnSnifferCommunicate(EventClass_Sniffer &evt);
    void Add_to_listbox(EventClass_Sniffer &evt);


    void OnClose( wxCloseEvent& event );

	void OnNotebook1_Page_Changed( wxNotebookEvent& event );
	void OnNotebook1_Page_Changing( wxNotebookEvent& event );

    void OnButtonClick_Toggle_Open_Interface( wxCommandEvent& event );
    void OnButtonClick_Toggle_Send_ARPs( wxCommandEvent& event );
    void OnButtonClick_Toggle_Send_Probes( wxCommandEvent& event );

    void Code_Toggle_Open_Interface();
    void Code_Toggle_Send_ARPs();
    void Code_Toggle_Send_Probes();

    void OnButtonClick_See_Detailed_MAC_Info( wxCommandEvent& event );
    void OnButtonClick_See_All_IPs( wxCommandEvent& event );
    void OnButtonClick_Quit( wxCommandEvent& event );
    void OnButtonClick_About( wxCommandEvent& event );

    void Toggle_Grey_OpenSocket(bool grey); /* Defined in dlg_toggle_grey.cpp */
    void Toggle_Grey_SendARP(bool grey);
    void Toggle_Grey_SendProbes(bool grey);

    void OnButtonClick_Select_All( wxCommandEvent& event );
	void OnButtonClick_De_Select_All( wxCommandEvent& event );
	void OnButtonClick_Invert_Selection( wxCommandEvent& event );

    void OnSetFocus_Text_NetworkInterface( wxFocusEvent& event )
    {
        m_button_Toggle_Open_Interface->SetDefault();
    }


public:

	Dialog_Main( wxWindow *parent );
	~Dialog_Main();
};

extern Dialog_Main *g_p_dlgmain;

#endif
