#ifndef H__ARPER
#define H__ARPER

#include "master_specs_for_dynamo_program.hpp"  /* const_max_qty_nets_to_arp */
#include "reusable/superarray.hpp"  /* SuperArray */
#include "net_types_basic.hpp"  /* NetworkAddress */

#include <wx/thread.h>

#if !wxUSE_THREADS
    #error "This sample requires thread support!"
#endif

#include "reusable/for_wxwidgets/ts_bool.hpp"

class ArperThread : public wxThread {

public:

    ThreadSafe_Boolean is_waiting;

    ThreadSafe_T<uintIP> current_ip;

private:

    bool DoOneNetwork(NetworkAddress const network_to_arp);

    uint_fast16_t const ms_btwn_arps; /* maximum of 65535 == 65 seconds */

    uint_fast8_t const qty_arp_each_address; /* maximum == 255 */

public:

    /* Populate this container after having constructed an ArperThread object */
    SuperArray<NetworkAddress,const_max_qty_nets_to_arp> nets;

public:

    ArperThread(uint_fast16_t const arg_ms_btwn_arps,
                uint_fast8_t const arg_qty_arp_each_address)

                : wxThread(wxTHREAD_JOINABLE),
                  ms_btwn_arps(arg_ms_btwn_arps),
                  qty_arp_each_address(arg_qty_arp_each_address)
                   {}

    void *Entry();
};

#endif


