#include <wx/app.h>
#include <wx/thread.h> /* SetConcurrency */
#include <wx/msgdlg.h> /* wxMessageBox if g_p_sdb allocation fails */
#include <wx/string.h> /* wxString */

#include "GUI_Dialog_Main.hpp"  /* g_p_dlgmain */
#include "database.hpp" /* g_p_sdb */

class App_Dynamo : public wxApp {
public:
    virtual bool OnInit()
	{
	    wxThread::SetConcurrency(3);
		/* Main thread for handling GUI, Sniffer thread,
		   and one more: Either Sniffer or Arper */

        try
        {
            g_p_sdb = new Sniffer_Database();
        }
        catch (...)
        {
            wxString str ( wxT( "    An attempt was made to allocate\n"
                                "a memory buffer on the heap of size " ) );

            str << (long unsigned)(sizeof(Sniffer_Database) / 1000000lu + 1);

            str += wxT( " megabytes.\n"
                   "    This attempt failed and Dynamo will now end.\n"
                   "Maybe try freeing up some memory and running\n"
                   "Dynamo again.");

            wxMessageBox(str,wxT("Memory allocation failure"),0,0,0,0);

            return true;
        }

        g_p_dlgmain = new Dialog_Main(0L);

        g_p_dlgmain->Show();   /* Just let this throw if it fails */

	    return true;
	}
};


IMPLEMENT_APP(App_Dynamo); /* This creates the "main" function */

