#ifndef HPP__PARSER
#define HPP__PARSER

#include "net_types_basic.hpp" /* uintMAC, uintIP, NetworkAddress */

bool ParseDecimalNumber_fast8(char const *const p,uint_fast8_t const max_chars,uint_fast8_t &sum);
bool ParseDecimalNumber_fast16(char const *const p,uint_fast8_t const max_chars,uint_fast16_t &sum);

bool ParseIP(char const *const p, uintIP &ip); /* e.g. 134.3.67.189 */

#include <wx/string.h> /* wxString */

wxString MakeStringFromMAC(uintMAC);
wxString MakeStringFromIP(uintIP);

#include "reusable/superarray.hpp"
#include "master_specs_for_dynamo_program.hpp"  /* const_max_qty_nets_to_arp */

bool GetNetworksFromString(wxString,
                           SuperArray<NetworkAddress,const_max_qty_nets_to_arp> &);

char const *Port_To_Protocol_Name(uint_fast16_t const port);


#endif
