#ifndef H__TS_BOOL
#define H__TS_BOOL

#include <wx/thread.h>

#if !wxUSE_THREADS
    #error "This sample requires thread support!"
#endif

template<class T>
class ThreadSafe_T {

protected:

    T obj;
    mutable wxCriticalSection cs;

public:

    ThreadSafe_T() : obj() {}

    void Set(T const &arg)
    {
        wxCriticalSectionLocker locker(this->cs);

        this->obj = arg;
    }

    T Get() const
    {
        wxCriticalSectionLocker locker(this->cs);

        return this->obj;
    }

};

class ThreadSafe_Boolean : public ThreadSafe_T<bool> {

public:

    /* Constructor of ThreadSafe_T<bool>
       initialises it to false */

    bool Get_And_Then_Set_False()
    {
        wxCriticalSectionLocker locker(this->cs);

        if ( !this->obj )
        {
            return false;
        }

        /* If we reach here then it was true */
        this->obj = false;

        return true;
    }
};

#endif
