#include "sniffer.hpp"

#include "reusable/lib_rawsock/rawsock.h"   /* RecvRawEtherFrame */

#include "globals.hpp"  /* g_s (The raw socket handle) */

#include "database.hpp"  /* g_p_sdb (The sniffer database) */

#include "frame_analysis.hpp"  /* The FrameAnalysis class */

void *SnifferThread::Entry()
{
    for (;;)
    {
        for (;;)
        {
            /* Keep checking to see if main GUI thread wants this thread to end! */
            if ( this->is_waiting.Get_And_Then_Set_False() )
            {
                return 0;
            }

            if ( RecvRawEtherFrame(g_s,&this->fi) ) /* Exits loop if we have a frame */
            {
                break;
            }

            //this->Sleep(5); /* Pcap has its own timeout facility */
        }

        FrameAnalysis fa(this->fi.buf, this->fi.buf + this->fi.len);

        g_p_sdb->SubmitFrameAnalysis(fa);
    }

    return 0; /* Just to suppress compiler warning */
}

