#ifndef HPP_SNIFFER_CUSTOM_WX_EVENT
#define HPP_SNIFFER_CUSTOM_WX_EVENT

#include <wx/wx.h>

#include "net_types_basic.hpp"  /* uintMAC */
#include "reusable/superarray.hpp"
#include "net_types_containers.hpp" /* Port_Data */
#include "master_specs_for_dynamo_program.hpp"  /* const_max_qty_ips_on_screen */

DECLARE_EVENT_TYPE( g_event_type_sniffer, -1 )  /* This line *declares* a global object */

struct On_Screen_Data_For_MAC {

    uintMAC mac;

    IntType_Qty_IP qty_private_ip, qty_public_ip;

    typedef SuperArray<uintIP,const_max_qty_ips_on_screen> ContainerType_IP;
    typedef ContainerType_IP::const_iterator CI_IP;
    ContainerType_IP container_of_ips;

    typedef SuperArray<uintPort,const_max_qty_ports_on_screen> ContainerType_Port;
    typedef ContainerType_Port::const_iterator CI_Port;
    ContainerType_Port container_of_ports;

    On_Screen_Data_For_MAC() : mac(0), qty_private_ip(0), qty_public_ip(0) {}

    On_Screen_Data_For_MAC &operator=(On_Screen_Data_For_MAC const &rhs)
    {
        this->~On_Screen_Data_For_MAC();

        ::new(this) On_Screen_Data_For_MAC(rhs);

        return *this;
    }
};

class EventClass_Sniffer : public wxCommandEvent
{
public:

    On_Screen_Data_For_MAC osdfm;

	EventClass_Sniffer( wxEventType arg_command_type = g_event_type_sniffer, int arg_id = 0 )
	:  wxCommandEvent(arg_command_type, arg_id) { }

    /* No need for copy-constructor, the default supplied one will do */

    // Required for sending with wxPostEvent()
	wxEvent *Clone() const
	{
	    return new EventClass_Sniffer(*this);
    }
};

typedef void (wxEvtHandler::*EventMemberFunctionPointer_Sniffer)(EventClass_Sniffer &);

// This #define simplifies the one below, and makes the syntax less
// ugly if you want to use Connect() instead of an event table.
#define EventHandler_Sniffer(func)                                         \
	(wxObjectEventFunction)(wxEventFunction)(wxCommandEventFunction)\
	wxStaticCastEvent(EventMemberFunctionPointer_Sniffer, &func)

// Define the event table entry. Yes, it really *does* end in a comma.
#define EVT_SNIFFER(id, fn)                                            \
	DECLARE_EVENT_TABLE_ENTRY( g_event_type_sniffer, id, wxID_ANY,  \
	(wxObjectEventFunction)(wxEventFunction)                     \
	(wxCommandEventFunction) wxStaticCastEvent(                  \
	EventMemberFunctionPointer_Sniffer, &fn ), (wxObject*) NULL ),

// Optionally, you can do a similar #define for EVT_SNIFFER_RANGE.
#define EVT_SNIFFER_RANGE(id1,id2, fn)                                 \
	DECLARE_EVENT_TABLE_ENTRY( g_event_type_sniffer, id1, id2,      \
	EventHandler_Sniffer(fn), (wxObject*) NULL ),

#endif
